package com.sun.kvem.javon.template;

import java.io.IOException;
import com.sun.kvem.javon.template.Template;
import com.sun.kvem.javon.template.TemplateData;
import com.sun.kvem.javon.model.JavonMapping;
import java.io.File;
import java.util.*;
import com.sun.kvem.javon.model.*;
import com.sun.kvem.javon.model.classdata.*;
import com.sun.kvem.javon.model.protocol.Serializer;
import com.sun.kvem.javon.model.protocol.binary.ComplexTypeSerializer;

public class InvocationAbstractionImpl extends Template {

    protected Class getTemplateOutputClass() {
        return com.sun.kvem.javon.model.JavonOutput.class;
    }

    protected com.sun.kvem.javon.model.JavonOutput getOutput() {
        return (com.sun.kvem.javon.model.JavonOutput) getOutputImpl();
    }

    public void runImpl(TemplateData __template_data)
        throws Exception {

    final com.sun.kvem.javon.model.JavonMapping data = (com.sun.kvem.javon.model.JavonMapping) __template_data;
/* Source line 7 */         
/* Source line 8 */         String outputDir = data.getServerOutputDirectory();
/* Source line 9 */         String packageName = data.getServerPackageName();
/* Source line 10 */         ProtocolSupport support = new ProtocolSupport(data, this, false);
/* Source line 11 */         setOut(support.getServletSupportPath("EndToEndGateways"));
/* Source line 12 */         getOutput().addCreatedFile(support.getServletSupportPath("EndToEndGateways"));
/* Source line 13 */         println("package " + support.serverSupportPackage() + ";");
/* Source line 14 */         println("");
/* Source line 15 */         Set imports = new HashSet();
/* Source line 16 */         MethodData[] methods = data.getMethods();
/* Source line 17 */         for (int methodIndex = 0; methodIndex < methods.length; methodIndex++) {
/* Source line 18 */             MethodData currentMethod = methods[methodIndex];
/* Source line 19 */             imports.add(currentMethod.getClassData().getClassName());
/* Source line 20 */             imports.addAll(Arrays.asList(currentMethod.getRequiredImports()));
/* Source line 21 */         }
/* Source line 22 */         Iterator iter = imports.iterator();
/* Source line 23 */         while (iter.hasNext()) {
/* Source line 24 */             String importClassName = (String) iter.next();
/* Source line 25 */             // only import the class if it is in a package
/* Source line 26 */             if (importClassName.indexOf('.') != -1) {
/* Source line 27 */                 println("import " + importClassName + ";");
/* Source line 28 */             }
/* Source line 29 */         }
/* Source line 30 */         println("");
/* Source line 31 */         println("import java.io.*;");
/* Source line 32 */         println("import javax.servlet.http.HttpSession;");
/* Source line 33 */         println("");
/* Source line 34 */         println("public class EndToEndGateways {");
/* Source line 35 */         for (int methodIndex = 0; methodIndex < methods.length; methodIndex++) {
/* Source line 36 */             MethodData currentMethod = methods[methodIndex];
/* Source line 37 */             String className = currentMethod.getImplementingClassName();
/* Source line 38 */             println("");
/* Source line 39 */             println("/**");
/* Source line 40 */             println("*  This class implements the application server connectivity specific to the needs.");
/* Source line 41 */             println("*/");
/* Source line 42 */             println("public static class " + className + " implements InvocationAbstraction {");
/* Source line 43 */             println("/**");
/* Source line 44 */             println("*  This method performs the actual invocation of server functionality. It is");
/* Source line 45 */             println("*  used by the servlet to delegate functionality to external classes.");
/* Source line 46 */             println("*");
/* Source line 47 */             println("*@param  clientID         The unique identifier of a client");
/* Source line 48 */             println("*@param  input            The stream from which we should read the parameters");
/* Source line 49 */             println("*      for the methods");
/* Source line 50 */             println("*@return                  The return value for the method NULL IS NOT");
/* Source line 51 */             println("*      SUPPORTED!!!!");
/* Source line 52 */             println("*@exception  IOException  Thrown when a protocol error occurs");
/* Source line 53 */             println("*/");
/* Source line 54 */             println("public Object invoke(HttpSession session, DataInput input) throws Exception {");
/* Source line 55 */             String inputName = "input";
/* Source line 56 */             ClassData[] paramTypes = currentMethod.getParameterTypes();
/* Source line 57 */             for(int i = 1 ; i <= paramTypes.length ; i++){
/* Source line 58 */                 if(paramTypes[i - 1].isArray()) {
/* Source line 59 */                     String arrayClassName = paramTypes[i - 1].getShortClassName();
/* Source line 60 */                 println("" + arrayClassName + " param" + i + ";");
/* Source line 61 */                 String typei = "type" + i;
/* Source line 62 */                 println("short " + typei + " = " + inputName + ".readShort(); // reading the type");
/* Source line 63 */                 println("if (" + typei + " == -1) { // NULL_TYPE) {");
/* Source line 64 */                 println("param" + i + " = null;");
/* Source line 65 */                 println("} else {");
/* Source line 66 */                 if (paramTypes[i - 1].getComponentType().isPrimitive()) {
/* Source line 67 */                     println("param" + i + " = (" + arrayClassName + ") Utility.readArray(input);");
/* Source line 68 */                 } else {
/* Source line 69 */                     String arrayName = paramTypes[i - 1].getShortClassName();
/* Source line 70 */                     ClassData component = paramTypes[i - 1].getComponentType();
/* Source line 71 */                     String componentName = component.getShortClassName();
/* Source line 72 */                     println("Object o = Utility.readArray(input);");
/* Source line 73 */                     println("if (o instanceof " + arrayName + ") {");
/* Source line 74 */                     println("param" + i + " = (" + arrayName + ") o;");
/* Source line 75 */                     println("} else {");
/* Source line 76 */                     println("Object[] objArray = (Object[]) o;");
/* Source line 77 */                     if (component.isArray()) {
/* Source line 78 */                         int componentBaseNameIndex = componentName.indexOf('[');
/* Source line 79 */                             String componentBaseName = componentName.substring(0, componentBaseNameIndex);
/* Source line 80 */                             String brackets = componentName.substring(componentBaseNameIndex);
/* Source line 81 */                             println("param" + i + " = new " + componentBaseName + "[objArray.length]" + brackets + ";");
/* Source line 82 */                         } else {
/* Source line 83 */                             println("param" + i + " = new " + componentName + "[objArray.length];");
/* Source line 84 */                         }
/* Source line 85 */                         println("for (int i = 0; i < objArray.length; i++) {");
/* Source line 86 */                         println("param" + i + "[i] = (" + componentName + ") objArray[i];");
/* Source line 87 */                         println("}");
/* Source line 88 */                         println("}");
/* Source line 89 */                     }
/* Source line 90 */                     println("}");
/* Source line 91 */                 } else {
/* Source line 92 */                     Serializer s = paramTypes[i - 1].getSerializer();
/* Source line 93 */                     
/* Source line 94 */                     if( s instanceof ComplexTypeSerializer ) {
/* Source line 95 */                         ((ComplexTypeSerializer)s).setClient( false );
/* Source line 96 */                     }
/* Source line 97 */                     String parami = "param" + i;
/* Source line 98 */                     int typeIndex = data.getValueForType(paramTypes[i - 1]);
/* Source line 99 */                     String typei = "type" + i;
/* Source line 100 */                     println("short " + typei + " = " + inputName + ".readShort(); // reading the type");
/* Source line 101 */                     println("");
/* Source line 102 */                     if (paramTypes[i - 1].isPrimitive()) {
/* Source line 103 */                         println("" + s.read(inputName, true, parami) + ";");
/* Source line 104 */                     } else {
/* Source line 105 */                         println("" + paramTypes[i - 1].getShortClassName() + " " + parami + ";");
/* Source line 106 */                         println("if (" + typei + " == -1) { // NULL_TYPE) {");
/* Source line 107 */                         println("" + parami + " = null;");
/* Source line 108 */                         println("} else {");
/* Source line 109 */                         println("" + s.read(inputName, false, parami) + ";");
/* Source line 110 */                         println("}");
/* Source line 111 */                     }
/* Source line 112 */                 }
/* Source line 113 */                 }
/* Source line 114 */                 
/* Source line 115 */                 String implementingClassName = currentMethod.getClassData().getClassName();
/* Source line 116 */                 boolean returnsValue = !currentMethod.getReturnType().equalsClass(Void.TYPE);
/* Source line 117 */                 if (currentMethod.getClassData().getClassName().indexOf('.') != -1) {
/* Source line 118 */                     println("" + implementingClassName + " instance = (" + implementingClassName + ")");
/* Source line 119 */                     println("session.getAttribute(\"" + implementingClassName + "\");");
/* Source line 120 */                     println("if (instance == null) {");
/* Source line 121 */                     println("instance = (" + implementingClassName + ") Class.forName(\"" + implementingClassName + "\").newInstance();");
/* Source line 122 */                     println("session.setAttribute(\"" + implementingClassName + "\", instance);");
/* Source line 123 */                     println("}");
/* Source line 124 */                     String methodName = currentMethod.getName();
/* Source line 125 */                     StringBuffer sb = new StringBuffer();
/* Source line 126 */                     if (returnsValue) {
/* Source line 127 */                         sb.append("return Utility.toObject(");
/* Source line 128 */                     }
/* Source line 129 */                     sb.append("instance.").append(methodName).append("(");
/* Source line 130 */                     for (int i = 0; i < paramTypes.length; i++) {
/* Source line 131 */                         if (i > 0) {
/* Source line 132 */                             sb.append(", ");
/* Source line 133 */                         }
/* Source line 134 */                         sb.append("param").append(i + 1);
/* Source line 135 */                     }
/* Source line 136 */                     sb.append(")");
/* Source line 137 */                     if (!returnsValue) {
/* Source line 138 */                         sb.append(";\nreturn Utility.VOID_VALUE;\n");
/* Source line 139 */                     } else {
/* Source line 140 */                         sb.append(");\n");
/* Source line 141 */                     }
/* Source line 142 */                     println("" + sb + "");
/* Source line 143 */                 } else {
/* Source line 144 */                     println("/*  The service class being referenced is in the root package, so it");
/* Source line 145 */                     println("*  is not possible to import it. Instead, the service is accessed");
/* Source line 146 */                     println("*  using Java's reflection API.");
/* Source line 147 */                     println("*/");
/* Source line 148 */                     println("Object instance = session.getAttribute(\"" + implementingClassName + "\");");
/* Source line 149 */                     println("if (instance == null) {");
/* Source line 150 */                     println("instance = Class.forName(\"" + implementingClassName + "\").newInstance();");
/* Source line 151 */                     println("session.setAttribute(\"" + implementingClassName + "\", instance);");
/* Source line 152 */                     println("}");
/* Source line 153 */                     println("Class[] signature = {");
/* Source line 154 */                     for (int i = 0; i < paramTypes.length; i++) {
/* Source line 155 */                         ClassData type = paramTypes[i];
/* Source line 156 */                         String typeString;
/* Source line 157 */                         if (type.isPrimitive()) {
/* Source line 158 */                             typeString = type.getWrapperType().getClassName() + ".TYPE";
/* Source line 159 */                         } else {
/* Source line 160 */                             typeString = type.getClassName() + ".class";
/* Source line 161 */                         }
/* Source line 162 */                         String comma = (i == paramTypes.length - 1) ? "" : ",";
/* Source line 163 */                         println("" + typeString + "" + comma + "");
/* Source line 164 */                     }
/* Source line 165 */                     println("};");
/* Source line 166 */                     println("Class clazz = instance.getClass();");
/* Source line 167 */                     println("try {");
/* Source line 168 */                     println("java.lang.reflect.Method method = clazz.getMethod(\"" + currentMethod.getName() + "\", signature);");
/* Source line 169 */                     println("Object[] args = {");
/* Source line 170 */                     for (int i = 0; i < paramTypes.length; i++) {
/* Source line 171 */                         String comma = (i == paramTypes.length - 1) ? "" : ",";
/* Source line 172 */                         if (paramTypes[i].isPrimitive()) {
/* Source line 173 */                             String cast = support.castToReference("param" + (i + 1), paramTypes[i]);
/* Source line 174 */                             println("" + cast + "" + comma + "");
/* Source line 175 */                         } else {
/* Source line 176 */                             println("param" + (i + 1) + "" + comma + "");
/* Source line 177 */                         }
/* Source line 178 */                     }
/* Source line 179 */                     println("};");
/* Source line 180 */                     if (returnsValue) {
/* Source line 181 */                         println("return method.invoke(instance, args);");
/* Source line 182 */                     } else {
/* Source line 183 */                         println("method.invoke(instance, args);");
/* Source line 184 */                         println("return Utility.VOID_VALUE;");
/* Source line 185 */                     }
/* Source line 186 */                     println("} catch (java.lang.reflect.InvocationTargetException e) {");
/* Source line 187 */                     println("try {");
/* Source line 188 */                     println("throw e.getTargetException();");
/* Source line 189 */                     println("} catch (Exception te) {");
/* Source line 190 */                     println("throw te;");
/* Source line 191 */                     println("} catch (Error te) {");
/* Source line 192 */                     println("throw te;");
/* Source line 193 */                     println("} catch (Throwable te) {");
/* Source line 194 */                     println("// won't reach here");
/* Source line 195 */                     println("return null;");
/* Source line 196 */                     println("}");
/* Source line 197 */                     println("}");
/* Source line 198 */                 }
/* Source line 199 */                 println("}");
/* Source line 200 */                 println("}");
/* Source line 201 */             } // end for loop interating over methods
/* Source line 202 */                 println("");
/* Source line 203 */             println("private static Object readObject(DataInput in) throws IOException {");
/* Source line 204 */             println("return Utility.readObject(in);");
/* Source line 205 */             println("}");
/* Source line 206 */             println("}");
    }

}
