package com.sun.kvem.javon.template;

import java.io.IOException;
import com.sun.kvem.javon.template.Template;
import com.sun.kvem.javon.template.TemplateData;
import com.sun.kvem.javon.model.JavonMapping;
import com.sun.kvem.javon.model.*;
import com.sun.kvem.javon.model.classdata.*;
import com.sun.kvem.javon.model.protocol.Serializer;
import com.sun.kvem.javon.model.protocol.binary.ComplexTypeSerializer;
import com.sun.kvem.javon.model.protocol.binary.PrimitiveTypeSerializer;
import java.io.*;
import java.util.*;
import java.text.*;

public class Protocol extends Template {

    protected Class getTemplateOutputClass() {
        return com.sun.kvem.javon.model.JavonOutput.class;
    }

    protected com.sun.kvem.javon.model.JavonOutput getOutput() {
        return (com.sun.kvem.javon.model.JavonOutput) getOutputImpl();
    }

    public void runImpl(TemplateData __template_data)
        throws Exception {

    final com.sun.kvem.javon.model.JavonMapping data = (com.sun.kvem.javon.model.JavonMapping) __template_data;
/* Source line 9 */         
/* Source line 10 */         final ProtocolSupport support = new ProtocolSupport(data, this, true);
/* Source line 11 */         final String EMPTY_ARRAY_FIELD = "_";
/* Source line 12 */         final String INVOCATION_CODE = "1";
/* Source line 13 */         final String RESULT_SUCCESSFUL = "1";
/* Source line 14 */         final String RESULT_EXCEPTION = "2";
/* Source line 15 */         final ClassData VOID_TYPE = data.getRegistry().getClassData(Void.TYPE);
/* Source line 16 */         // Set up a protocol version string
/* Source line 17 */         DateFormat dateFormat = new SimpleDateFormat("d-MMM-yyyy/HH:mm:ss-z", Locale.US);
/* Source line 18 */         final String VERSION_STRING = dateFormat.format(new Date());
/* Source line 19 */         data.set("VERSION", VERSION_STRING);
/* Source line 20 */         
/* Source line 21 */         setOut(support.getClientPath(data.getClientClassName()));
/* Source line 22 */         getOutput().addCreatedFile(support.getClientPath(data.getClientClassName()));
/* Source line 23 */         
/* Source line 24 */         // The output file should be recognized by the development
/* Source line 25 */         // environment as a J2ME file
/* Source line 26 */         getOutput().setMIDlet(true);
/* Source line 27 */         
/* Source line 28 */         // Set the output package
/* Source line 29 */         println("" + support.clientPackageLine() + "");
/* Source line 30 */         
/* Source line 31 */         // Imports
/* Source line 32 */         println("import java.util.*;");
/* Source line 33 */         println("import java.io.*;");
/* Source line 34 */         println("import javax.microedition.io.*;");
/* Source line 35 */         
/* Source line 36 */         // A MIDlet needs extra imports
/* Source line 37 */         if (data.isMIDlet()) {
/* Source line 38 */             println("import javax.microedition.midlet.*;");
/* Source line 39 */             println("import javax.microedition.lcdui.*;");
/* Source line 40 */             println("");
/* Source line 41 */             println("/**");
/* Source line 42 */             println("* This class provides J2ME client access to J2EE services. It extends MIDlet,");
/* Source line 43 */             println("* and should be modified in order to actually use the methods that it defines.");
/* Source line 44 */             println("* Note that any changes to this class will be erased if this class is");
/* Source line 45 */             println("* regenerated. For this reason it is recommended that for general use you");
/* Source line 46 */             println("* generate a stand-alone class instead of a MIDlet.");
/* Source line 47 */             println("*");
/* Source line 48 */             println("* The methods in this class are not thread-safe.");
/* Source line 49 */             println("*/");
/* Source line 50 */         } else {
/* Source line 51 */             println("");
/* Source line 52 */             println("/**");
/* Source line 53 */             println("* This class provides J2ME client access to J2EE services. It is created");
/* Source line 54 */             println("* by a code-generator; you should note that any changes you make will");
/* Source line 55 */             println("* be lost if you re-generate the code.");
/* Source line 56 */             println("*");
/* Source line 57 */             println("* The methods in this class are not thread-safe.");
/* Source line 58 */             println("*/");
/* Source line 59 */         }
/* Source line 60 */         println("");
/* Source line 61 */         // Determine the modifier used for methods such as "invokeServer"
/* Source line 62 */         String dynamicMethodModifier = data.isDynamicInvocationSupported()
/* Source line 63 */             ? "public"
/* Source line 64 */             : "private";
/* Source line 65 */         
/* Source line 66 */         if(data.isMIDlet()) {
/* Source line 67 */             println("public class " + data.getClientClassName() + " extends MIDlet {");
/* Source line 68 */         } else {
/* Source line 69 */             println("public class " + data.getClientClassName() + " {");
/* Source line 70 */         }
/* Source line 71 */         println("");
/* Source line 72 */         final ClassData[] supportedReturnTypes = data.getReturnTypes();
/* Source line 73 */         final ClassData[] supportedParamTypes = data.getParameterTypes();
/* Source line 74 */         final int ARRAY_TYPE = -2;
/* Source line 75 */         for (int i = 0 ; i < supportedReturnTypes.length; i++) {
/* Source line 76 */             ClassData classData = supportedReturnTypes[i];
/* Source line 77 */             while (classData.isArray()) {
/* Source line 78 */                 classData = classData.getComponentType();
/* Source line 79 */             }
/* Source line 80 */             classData.getSerializer().setType(String.valueOf(data.getValueForType(classData)));
/* Source line 81 */         }
/* Source line 82 */         for (int i = 0 ; i < supportedParamTypes.length; i++) {
/* Source line 83 */             ClassData classData = supportedParamTypes[i];
/* Source line 84 */             while (classData.isArray()) {
/* Source line 85 */                 classData = classData.getComponentType();
/* Source line 86 */             }
/* Source line 87 */             classData.getSerializer().setType(String.valueOf(data.getValueForType(classData)));
/* Source line 88 */         }
/* Source line 89 */         
/* Source line 90 */         // generate method ID constants, if they are supported
/* Source line 91 */         if(data.isDynamicInvocationSupported()) {
/* Source line 92 */             MethodData[] methods = data.getMethods();
/* Source line 93 */             String[] constantNames = support.computeConstantNames(methods);
/* Source line 94 */             for(int i = 0 ; i < methods.length ; i++) {
/* Source line 95 */                 println("public static final int " + constantNames[i] + " = " + methods[i].getRequestID() + ";");
/* Source line 96 */             }
/* Source line 97 */         } // end if isDynamicInvocationSupported()
/* Source line 98 */             
/* Source line 99 */             println("/** The URL of the servlet gateway */");
/* Source line 100 */         println("private String serverURL;");
/* Source line 101 */         println("");
/* Source line 102 */         println("/** The session cookie of this client */");
/* Source line 103 */         println("private String sessionCookie;");
/* Source line 104 */         println("");
/* Source line 105 */         // We don't need the following unless we actually make no-argument
/* Source line 106 */         // calls.
/* Source line 107 */         if (support.noArgumentCallExists(data.getMethods()) || data.isReturnTypeSupported(Void.TYPE)) {
/* Source line 108 */             println("/**");
/* Source line 109 */             println("* Empty array used for no-argument calls, and to represent the value \"void\"");
/* Source line 110 */             println("*/");
/* Source line 111 */             println("");
/* Source line 112 */             println("private final static Object[] " + EMPTY_ARRAY_FIELD + " = new Object[0];");
/* Source line 113 */             println("");
/* Source line 114 */         }
/* Source line 115 */         
/* Source line 116 */         if(data.isGroupingSupported()){
/* Source line 117 */             println("/**");
/* Source line 118 */             println("* This vector contains the request ids for queued calls.");
/* Source line 119 */             println("*/");
/* Source line 120 */             println("private Vector groupRequestID;");
/* Source line 121 */             println("");
/* Source line 122 */             println("/**");
/* Source line 123 */             println("* This vector contains the parameters for the queued calls.");
/* Source line 124 */             println("*/");
/* Source line 125 */             println("private Vector groupParameters;");
/* Source line 126 */             println("");
/* Source line 127 */         } // end of grouping constants
/* Source line 128 */             println("");
/* Source line 129 */         if(data.isMIDlet()) {
/* Source line 130 */             println("");
/* Source line 131 */             println("public void startApp() {");
/* Source line 132 */             println("serverURL = \"" + data.getServletURL() + "\";");
/* Source line 133 */             support.traceLight("Initializing MIDlet, serverURL = {0}", "serverURL");
/* Source line 134 */             println("}");
/* Source line 135 */             println("");
/* Source line 136 */             println("public void destroyApp(boolean b) {");
/* Source line 137 */             println("}");
/* Source line 138 */             println("");
/* Source line 139 */             println("public void pauseApp() {");
/* Source line 140 */             println("}");
/* Source line 141 */         } else {
/* Source line 142 */             println("");
/* Source line 143 */             println("/**");
/* Source line 144 */             println("* Constructs a new " + data.getClientClassName() + "");
/* Source line 145 */             println("* and initializes the URL to the servlet gateway from a hard-coded value.");
/* Source line 146 */             println("*/");
/* Source line 147 */             println("public " + data.getClientClassName() + "() {");
/* Source line 148 */             println("this(\"" + data.getServletURL() + "\");");
/* Source line 149 */             println("}");
/* Source line 150 */             println("");
/* Source line 151 */             println("/**");
/* Source line 152 */             println("* Constructs a new " + data.getClientClassName() + "");
/* Source line 153 */             println("* and initializes the URL to the servlet gateway from the given value");
/* Source line 154 */             println("*");
/* Source line 155 */             println("* @param serverURL URL of the deployed servlet");
/* Source line 156 */             println("*/");
/* Source line 157 */             println("public " + data.getClientClassName() + "(String serverURL) {");
/* Source line 158 */             println("this.serverURL = serverURL;");
/* Source line 159 */             support.traceLight("Creating " + data.getClientClassName() + ", serverURL = {0}", "serverURL");
/* Source line 160 */             println("}");
/* Source line 161 */         }
/* Source line 162 */         
/* Source line 163 */         if (data.isStubGeneration()) { // generate stub methods
/* Source line 164 */             MethodData[] methods = data.getMethods();
/* Source line 165 */             // compute parameter line string (e.g "(int a0, char a1, String[] a2)")
/* Source line 166 */             // at the same time, compute the object array contents
/* Source line 167 */             // (e.g. { new Integer(a0), new Character(a1), s2 }
/* Source line 168 */             for (int i = 0; i < methods.length; i++) {
/* Source line 169 */                 MethodData method = methods[i];
/* Source line 170 */                 ClassData returnType = method.getReturnType();
/* Source line 171 */                 ClassData[] paramTypes = method.getParameterTypes();
/* Source line 172 */                 String[] names = method.getParameterNames();
/* Source line 173 */                 String methodName = method.getStubMethodName();
/* Source line 174 */                 StringBuffer parameterLine = new StringBuffer();
/* Source line 175 */                 for (int j = 0; j < paramTypes.length; j++) {
/* Source line 176 */                     if (j > 0) {
/* Source line 177 */                         parameterLine.append(", ");
/* Source line 178 */                     }
/* Source line 179 */                     parameterLine.append(paramTypes[j].getShortClassName() + " " + names[j]);
/* Source line 180 */                 }
/* Source line 181 */                 String[] argArrayElements = new String[paramTypes.length];
/* Source line 182 */                 for (int j = 0; j < paramTypes.length; j++) {
/* Source line 183 */                     ClassData type = paramTypes[j];
/* Source line 184 */                     String comma = (j == paramTypes.length - 1) ? "" : ",";
/* Source line 185 */                     argArrayElements[j] = support.castToReference(names[j], type) + comma;
/* Source line 186 */                 }
/* Source line 187 */                 String methodString;
/* Source line 188 */                 if (data.isDynamicInvocationSupported()) {
/* Source line 189 */                     methodString = method.getMethodConstantName();
/* Source line 190 */                 } else {
/* Source line 191 */                     methodString = String.valueOf(method.getRequestID());
/* Source line 192 */                 }
/* Source line 193 */                 if (data.isSynchronousSupported()) {
/* Source line 194 */                     println("public " + returnType.getShortClassName() + " " + methodName + "(" + parameterLine + ") throws IOException {");
/* Source line 195 */                     String args = "args";
/* Source line 196 */                     if (argArrayElements.length > 0) {
/* Source line 197 */                         println("Object[] args = new Object[] {");
/* Source line 198 */                         for (int j = 0; j < argArrayElements.length; j++) {
/* Source line 199 */                             println("" + argArrayElements[j] + "");
/* Source line 200 */                         }
/* Source line 201 */                         println("};");
/* Source line 202 */                     } else {
/* Source line 203 */                         args = EMPTY_ARRAY_FIELD;
/* Source line 204 */                     }
/* Source line 205 */                     support.traceMedium("Calling server method " + method.getClassData().getCanonicalName() + "." + method.getName() + "()");
/* Source line 206 */                     for (int k = 0; k < argArrayElements.length; k++) {
/* Source line 207 */                         support.traceHeavy("args[" + k + "] = {0}", "args[" + k + "]");
/* Source line 208 */                     }
/* Source line 209 */                     String callString = "invokeServer(" + methodString + ", " + args + ")";
/* Source line 210 */                     if (returnType.equalsClass(Void.TYPE)) {
/* Source line 211 */                         println("" + callString + ";");
/* Source line 212 */                     } else {
/* Source line 213 */                         println("return " + support.castFromReference(callString, returnType) + ";");
/* Source line 214 */                     }
/* Source line 215 */                     // close the stub method
/* Source line 216 */                     println("}");
/* Source line 217 */                     println("");
/* Source line 218 */                 } // end synchronous stub
/* Source line 219 */                     if (data.isGroupingSupported()) {
/* Source line 220 */                     println("public void " + methodName + "Grouped(" + parameterLine + ") throws IOException {");
/* Source line 221 */                     String args = "args";
/* Source line 222 */                     if (argArrayElements.length > 0) {
/* Source line 223 */                         println("Object[] args = new Object[] {");
/* Source line 224 */                         for (int j = 0; j < argArrayElements.length; j++) {
/* Source line 225 */                             println("" + argArrayElements[j] + "");
/* Source line 226 */                         }
/* Source line 227 */                         println("};");
/* Source line 228 */                     } else {
/* Source line 229 */                         args = EMPTY_ARRAY_FIELD;
/* Source line 230 */                     }
/* Source line 231 */                     support.traceMedium("Queuing call to server method " + method.getClassData().getCanonicalName() + "." + method.getName() + "()");
/* Source line 232 */                     for (int k = 0; k < argArrayElements.length; k++) {
/* Source line 233 */                         support.traceHeavy("args[" + k + "] = {0}", "args[" + k + "]");
/* Source line 234 */                     }
/* Source line 235 */                     println("invokeGrouped(" + methodString + ", " + args + ");");
/* Source line 236 */                     println("}");
/* Source line 237 */                     println("");
/* Source line 238 */                 } // end grouped stub
/* Source line 239 */                 } // end loop over methods
/* Source line 240 */             } // finish generating stubs
/* Source line 241 */             
/* Source line 242 */             TemplateMacro openInputStream = new TemplateMacro(this) {
/* Source line 243 */                 public void define() {
/* Source line 244 */                     println("int response;");
/* Source line 245 */                 println("try {");
/* Source line 246 */                 println("response = connection.getResponseCode();");
/* Source line 247 */                 println("} catch (IOException e) {");
/* Source line 248 */                 println("throw new IOException(\"No response from \" + serverURL);");
/* Source line 249 */                 println("}");
/* Source line 250 */                 println("if (response != 200) {");
/* Source line 251 */                 println("throw new IOException(response + \" \" + connection.getResponseMessage());");
/* Source line 252 */                 println("}");
/* Source line 253 */                 println("DataInputStream input = connection.openDataInputStream();");
/* Source line 254 */                 println("String sc = connection.getHeaderField(\"set-cookie\");");
/* Source line 255 */                 println("if (sc != null) {");
/* Source line 256 */                 println("sessionCookie = sc;");
/* Source line 257 */                 println("}");
/* Source line 258 */                 println("short errorCode = input.readShort();");
/* Source line 259 */                 println("if (errorCode != " + RESULT_SUCCESSFUL + ") {");
/* Source line 260 */                 println("// there was a remote exception");
/* Source line 261 */                 println("throw new IOException((String) readObject(input));");
/* Source line 262 */                 println("}");
/* Source line 263 */             }
/* Source line 264 */         };
/* Source line 265 */         
/* Source line 266 */         // if both grouping and single calls are used, it is best to put the contents
/* Source line 267 */         // of openInputStream into a separate method
/* Source line 268 */         if (data.isGroupingSupported() && data.isSynchronousSupported()) {
/* Source line 269 */             println("private DataInputStream openInput(HttpConnection connection) throws IOException {");
/* Source line 270 */             openInputStream.write();
/* Source line 271 */             println("return input;");
/* Source line 272 */             println("}");
/* Source line 273 */             // redefine openInputStream to call the method we just created.
/* Source line 274 */             openInputStream = new TemplateMacro(this) { public void define() {
/* Source line 275 */                 println("DataInputStream input = openInput(connection);");
/* Source line 276 */             }};
/* Source line 277 */         }
/* Source line 278 */         if(data.isGroupingSupported()){
/* Source line 279 */             println("/**");
/* Source line 280 */             println("*  This method performes caches the parameters and invokes the method only");
/* Source line 281 */             println("*  upon the getGroupedResults() method. This allows several calls to");
/* Source line 282 */             println("*  services on the server to be made in a single HTTP request/response.");
/* Source line 283 */             println("*");
/* Source line 284 */             println("*@param  requestID   The id of the server service (method) we wish to invoke.");
/* Source line 285 */             println("*@param  parameters  The parameters that should be passed to the server (type");
/* Source line 286 */             println("*      safety is not checked by this method!)");
/* Source line 287 */             println("*@param  returnType  Description of Parameter");
/* Source line 288 */             println("*/");
/* Source line 289 */             println("" + dynamicMethodModifier + " void invokeGrouped(int requestID, Object[] parameters) {");
/* Source line 290 */             println("if ( groupParameters == null ) {");
/* Source line 291 */             println("groupParameters = new Vector();");
/* Source line 292 */             println("groupRequestID = new Vector();");
/* Source line 293 */             println("}");
/* Source line 294 */             println("");
/* Source line 295 */             println("if ( groupParameters.size() == Short.MAX_VALUE ) {");
/* Source line 296 */             println("throw new ArrayIndexOutOfBoundsException(\"Exceeded grouping limit\");");
/* Source line 297 */             println("}");
/* Source line 298 */             println("");
/* Source line 299 */             println("groupParameters.addElement(parameters);");
/* Source line 300 */             println("groupRequestID.addElement(new Integer(requestID));");
/* Source line 301 */             println("}");
/* Source line 302 */             println("");
/* Source line 303 */             println("/**");
/* Source line 304 */             println("*  Sends queued methods calls to the server in a single connection.");
/* Source line 305 */             println("*");
/* Source line 306 */             println("*@return                  An enumeration of the results returned from the");
/* Source line 307 */             println("*      server VOID methods are skipped automatically.");
/* Source line 308 */             println("*@exception  IOException  When a communication error or a remote exception");
/* Source line 309 */             println("* occurs");
/* Source line 310 */             println("*/");
/* Source line 311 */             println("public Enumeration getGroupedResults() throws IOException {");
/* Source line 312 */             println("HttpConnection connection = (HttpConnection) Connector.open( serverURL );");
/* Source line 313 */             println("connection.setRequestMethod(\"POST\");");
/* Source line 314 */             println("");
/* Source line 315 */             println("if (sessionCookie == null) {");
/* Source line 316 */             println("// if this is the first time this client contatcs the server,");
/* Source line 317 */             println("// verify that the version matches");
/* Source line 318 */             println("connection.setRequestProperty(\"version\", \"" + VERSION_STRING + "\");");
/* Source line 319 */             println("} else {");
/* Source line 320 */             println("connection.setRequestProperty(\"cookie\", sessionCookie);");
/* Source line 321 */             println("}");
/* Source line 322 */             println("");
/* Source line 323 */             println("DataOutputStream output = connection.openDataOutputStream();");
/* Source line 324 */             println("");
/* Source line 325 */             println("// write the client ID and invocation code");
/* Source line 326 */             println("writeObject(output, this);");
/* Source line 327 */             println("");
/* Source line 328 */             println("Vector results = new Vector();");
/* Source line 329 */             println("int calls = groupParameters.size();");
/* Source line 330 */             println("Enumeration parameterEnum = groupParameters.elements();");
/* Source line 331 */             println("Enumeration requestEnum = groupRequestID.elements();");
/* Source line 332 */             println("");
/* Source line 333 */             println("// write the size of the group");
/* Source line 334 */             support.traceMedium("Executing \" + groupParameters.size() + \" queued calls");
/* Source line 335 */             println("output.writeShort(( short ) groupParameters.size());");
/* Source line 336 */             println("");
/* Source line 337 */             println("for (int i = 0; i < calls; i++) {");
/* Source line 338 */             println("Object[] parameters = (Object[]) groupParameters.elementAt(i);");
/* Source line 339 */             println("int requestID = ((Integer) groupRequestID.elementAt(i)).intValue();");
/* Source line 340 */             println("output.writeInt(requestID);");
/* Source line 341 */             println("for (int j = 0; j < parameters.length; j++ ) {");
/* Source line 342 */             support.traceHeavy("Invoking server with requestID {0}", "requestID");
/* Source line 343 */             println("writeObject(output, parameters[j]);");
/* Source line 344 */             println("}");
/* Source line 345 */             println("}");
/* Source line 346 */             println("");
/* Source line 347 */             println("groupParameters.removeAllElements();");
/* Source line 348 */             println("groupRequestID.removeAllElements();");
/* Source line 349 */             println("");
/* Source line 350 */             openInputStream.write();
/* Source line 351 */             println("");
/* Source line 352 */             println("for (int i = 0; i < calls; i++) {");
/* Source line 353 */             support.traceHeavy("Reading return value");
/* Source line 354 */             println("Object returnValue = readObject(input);");
/* Source line 355 */             support.traceMedium("Returned value: {0}", "returnValue");
/* Source line 356 */             if (data.isReturnTypeSupported(VOID_TYPE)) {
/* Source line 357 */                 println("if (returnValue != _ /* void return type */) {");
/* Source line 358 */                 println("results.addElement(returnValue);");
/* Source line 359 */                 println("}");
/* Source line 360 */             } else {
/* Source line 361 */                 println("results.addElement(returnValue);");
/* Source line 362 */             }
/* Source line 363 */             println("}");
/* Source line 364 */             println("");
/* Source line 365 */             println("output.close();");
/* Source line 366 */             println("input.close();");
/* Source line 367 */             println("connection.close();");
/* Source line 368 */             println("return results.elements();");
/* Source line 369 */             println("}");
/* Source line 370 */         }
/* Source line 371 */         
/* Source line 372 */         if (data.isSynchronousSupported()){
/* Source line 373 */             println("");
/* Source line 374 */             println("/**");
/* Source line 375 */             println("*  This method performes a dynamic invocation on the server. It is generic in");
/* Source line 376 */             println("*  order to reduce the code size.");
/* Source line 377 */             println("*");
/* Source line 378 */             println("*@param  requestID        The id of the server service (method) we wish to");
/* Source line 379 */             println("*      invoke.");
/* Source line 380 */             println("*@param  parameters       The parameters that should be passed to the server");
/* Source line 381 */             println("*      (type safety is not checked by this method!)");
/* Source line 382 */             println("*@param  returnType       Is used to indicate the return type we should read");
/* Source line 383 */             println("*      from the server");
/* Source line 384 */             println("*@return                  The return value from the invoked service");
/* Source line 385 */             println("*@exception  IOException  When a communication error or a remove exception");
/* Source line 386 */             println("* occurs");
/* Source line 387 */             println("*/");
/* Source line 388 */             println("" + dynamicMethodModifier + " Object invokeServer(int requestID, Object[] parameters) throws IOException {");
/* Source line 389 */             println("HttpConnection connection = (HttpConnection) Connector.open( serverURL );");
/* Source line 390 */             println("connection.setRequestMethod(HttpConnection.POST);");
/* Source line 391 */             println("connection.setRequestProperty(\"Content-Type\", \"application/octet-stream\");");
/* Source line 392 */             println("connection.setRequestProperty(\"Accept\", \"application/octet-stream\");");
/* Source line 393 */             println("");
/* Source line 394 */             println("if (sessionCookie == null) {");
/* Source line 395 */             println("// if this is the first time this client contatcs the server,");
/* Source line 396 */             println("// verify that the version matches");
/* Source line 397 */             println("connection.setRequestProperty(\"version\", \"" + VERSION_STRING + "\");");
/* Source line 398 */             println("} else {");
/* Source line 399 */             println("connection.setRequestProperty(\"cookie\", sessionCookie);");
/* Source line 400 */             println("}");
/* Source line 401 */             println("");
/* Source line 402 */             println("DataOutputStream output = connection.openDataOutputStream();");
/* Source line 403 */             println("");
/* Source line 404 */             support.traceHeavy("Invoking server with requestID {0}", "requestID");
/* Source line 405 */             println("writeObject(output, this);");
/* Source line 406 */             println("");
/* Source line 407 */             println("/* Write the byte signifying that only one call");
/* Source line 408 */             println("* is being made.");
/* Source line 409 */             println("*/");
/* Source line 410 */             println("output.writeShort(1 /* one call to be made to the server */);");
/* Source line 411 */             println("");
/* Source line 412 */             println("output.writeInt(requestID);");
/* Source line 413 */             println("for (int i = 0; i < parameters.length; i++ ) {");
/* Source line 414 */             println("writeObject(output, parameters[i]);");
/* Source line 415 */             println("}");
/* Source line 416 */             println("");
/* Source line 417 */             println("" + openInputStream.get() + "");
/* Source line 418 */             support.traceHeavy("Reading return value");
/* Source line 419 */             println("Object returnValue = readObject(input);");
/* Source line 420 */             support.traceMedium("Returned value: {0}", "returnValue");
/* Source line 421 */             println("");
/* Source line 422 */             println("output.close();");
/* Source line 423 */             println("input.close();");
/* Source line 424 */             println("connection.close();");
/* Source line 425 */             println("return returnValue;");
/* Source line 426 */             println("}");
/* Source line 427 */         }
/* Source line 428 */         println("");
/* Source line 429 */         println("private void writeObject(DataOutputStream out, Object o) throws IOException {");
/* Source line 430 */         String _output = "out";
/* Source line 431 */         String varName = "o";
/* Source line 432 */         println("if (o == this) {");
/* Source line 433 */         println("out.writeShort(" + INVOCATION_CODE + " /* invocation code */);");
/* Source line 434 */         println("} else if (o == null) {");
/* Source line 435 */         println("out.writeShort(-1);");
/* Source line 436 */         if (data.isArrayParameterSupported()) {
/* Source line 437 */             println("} else if (o.getClass().isArray()) {");
/* Source line 438 */             println("out.writeShort(" + ARRAY_TYPE + " /* ARRAY TYPE */);");
/* Source line 439 */             Set primitiveArrayParamTypes = new HashSet();
/* Source line 440 */             Set objectArrayParamTypes = new HashSet();
/* Source line 441 */             for (int i = 0; i < supportedParamTypes.length; i++) {
/* Source line 442 */                 ClassData type = supportedParamTypes[i];
/* Source line 443 */                 if (type.isArray()) {
/* Source line 444 */                     type = type.getComponentType();
/* Source line 445 */                     if (type.isPrimitive()) {
/* Source line 446 */                         primitiveArrayParamTypes.add(type);
/* Source line 447 */                     } else {
/* Source line 448 */                         if( type.getSerializer() instanceof PrimitiveTypeSerializer ) {
/* Source line 449 */                             continue;
/* Source line 450 */                         }
/* Source line 451 */                         objectArrayParamTypes.add(type);
/* Source line 452 */                     }
/* Source line 453 */                 }
/* Source line 454 */             }
/* Source line 455 */             String elseClause = "";
/* Source line 456 */             for (Iterator i = primitiveArrayParamTypes.iterator(); i.hasNext(); ) {
/* Source line 457 */                 ClassData type = (ClassData) i.next();
/* Source line 458 */                 Serializer s = type.getSerializer();
/* Source line 459 */                 println("" + elseClause + "if (o instanceof " + type.getShortClassName() + "[]) {");
/* Source line 460 */                 println("" + type.getShortClassName() + "[] array = (" + type.getShortClassName() + "[]) o;");
/* Source line 461 */                 println("" + s.writeType("out") + "");
/* Source line 462 */                 println("out.writeShort(array.length);");
/* Source line 463 */                 println("for (int i = 0; i < array.length; i++) {");
/* Source line 464 */                 println("" + s.writeObject("out", "array[i]") + "");
/* Source line 465 */                 println("}");
/* Source line 466 */                 println("}");
/* Source line 467 */                 elseClause = "else ";
/* Source line 468 */             } // end for loop
/* Source line 469 */                 if (!objectArrayParamTypes.isEmpty()) {
/* Source line 470 */                 if (elseClause.length() > 0) {
/* Source line 471 */                     println("else {");
/* Source line 472 */                 }
/* Source line 473 */                 println("Object[] array = (Object[]) o;");
/* Source line 474 */                 if (objectArrayParamTypes.size() == 1) {
/* Source line 475 */                     ClassData type = (ClassData) objectArrayParamTypes.iterator().next();
/* Source line 476 */                     println("" + type.getSerializer().writeType("out") + "");
/* Source line 477 */                 } else {
/* Source line 478 */                     Iterator i = objectArrayParamTypes.iterator();
/* Source line 479 */                     ClassData type = (ClassData) i.next();
/* Source line 480 */                     println("if (o instanceof " + type.getShortClassName() + "[]) {");
/* Source line 481 */                     println("" + type.getSerializer().writeType("out") + "");
/* Source line 482 */                     while (i.hasNext()) {
/* Source line 483 */                         type = (ClassData) i.next();
/* Source line 484 */                         println("} else if ( o instanceof " + type.getShortClassName() + "[]) {");
/* Source line 485 */                         println("" + type.getSerializer().writeType("out") + "");
/* Source line 486 */                     } // end while
/* Source line 487 */                         println("}");
/* Source line 488 */                 } // end if size == 1
/* Source line 489 */                     println("out.writeInt(array.length);");
/* Source line 490 */                 println("for (int i = 0; i < array.length; i++) {");
/* Source line 491 */                 println("writeObject(out, array[i]);");
/* Source line 492 */                 println("}");
/* Source line 493 */                 if (elseClause.length() > 0) {
/* Source line 494 */                     println("}");
/* Source line 495 */                 }
/* Source line 496 */             } // end if support object array
/* Source line 497 */             }
/* Source line 498 */             Set writableTypes = new HashSet();
/* Source line 499 */         for( int i = 0; i < supportedParamTypes.length; i++ ) {
/* Source line 500 */             ClassData type = supportedParamTypes[i];
/* Source line 501 */             if( !type.isPrimitive() && type.getSerializer() instanceof PrimitiveTypeSerializer ) {
/* Source line 502 */                 continue;
/* Source line 503 */             }
/* Source line 504 */             writableTypes.add( type );
/* Source line 505 */         }
/* Source line 506 */         for( Iterator it = writableTypes.iterator(); it.hasNext(); ) {
/* Source line 507 */             ClassData classData = (ClassData)it.next();
/* Source line 508 */             if (classData.equals(VOID_TYPE)) {
/* Source line 509 */                 continue;
/* Source line 510 */             }
/* Source line 511 */             if (!classData.isArray()) {
/* Source line 512 */                 String className;
/* Source line 513 */                 if (classData.isPrimitive()) {
/* Source line 514 */                     className = classData.getWrapperType().getShortClassName();
/* Source line 515 */                 } else {
/* Source line 516 */                     className = classData.getShortClassName();
/* Source line 517 */                 }
/* Source line 518 */                 Serializer s = classData.getSerializer();
/* Source line 519 */                 if( s instanceof ComplexTypeSerializer ) {
/* Source line 520 */                     ((ComplexTypeSerializer)s).setClient( support.isClient());
/* Source line 521 */                 }
/* Source line 522 */                 println("} else if (o instanceof " + className + ") {");
/* Source line 523 */                 println("" + s.writeType(_output) + "");
/* Source line 524 */                 println("" + s.writeObject(_output, support.castFromReference(varName, classData)) + "");
/* Source line 525 */             }
/* Source line 526 */         }
/* Source line 527 */         println("} else {");
/* Source line 528 */         println("// default if a data type is not supported");
/* Source line 529 */         println("throw new IllegalArgumentException(");
/* Source line 530 */         println("\"Unsupported parameter type: \" + o.getClass());");
/* Source line 531 */         println("}");
/* Source line 532 */         println("}");
/* Source line 533 */         println("");
/* Source line 534 */         println("private static Object readObject(DataInput in) throws IOException {");
/* Source line 535 */         String _input = "in";
/* Source line 536 */         // Read primitive types
/* Source line 537 */         println("int type = in.readShort();");
/* Source line 538 */         println("int length;");
/* Source line 539 */         println("switch (type) {");
/* Source line 540 */         Set readableTypes = new HashSet();
/* Source line 541 */         for( int i = 0; i < supportedReturnTypes.length; i++ ) {
/* Source line 542 */             ClassData type = supportedReturnTypes[i];
/* Source line 543 */             if( !type.isPrimitive() && type.getSerializer() instanceof PrimitiveTypeSerializer ) {
/* Source line 544 */                 continue;
/* Source line 545 */             }
/* Source line 546 */             readableTypes.add( type );
/* Source line 547 */         }
/* Source line 548 */         for( Iterator it = readableTypes.iterator(); it.hasNext(); ) {
/* Source line 549 */             ClassData supportedType = (ClassData)it.next();
/* Source line 550 */             if (!supportedType.isArray()) {
/* Source line 551 */                 String typeName;
/* Source line 552 */                 if (supportedType.isPrimitive()) {
/* Source line 553 */                     typeName = supportedType.getWrapperType().getShortClassName();
/* Source line 554 */                 } else {
/* Source line 555 */                     typeName = supportedType.getShortClassName();
/* Source line 556 */                 }
/* Source line 557 */                 Serializer s = supportedType.getSerializer();
/* Source line 558 */                 if( s instanceof ComplexTypeSerializer ) {
/* Source line 559 */                     ((ComplexTypeSerializer)s).setClient( support.isClient());
/* Source line 560 */                 }
/* Source line 561 */                 println("case " + s.getType() + ":");
/* Source line 562 */                 if (supportedType.equals(VOID_TYPE)) {
/* Source line 563 */                     println("return " + EMPTY_ARRAY_FIELD + ";");
/* Source line 564 */                 } else {
/* Source line 565 */                     println("" + s.readAndReturnObject(_input) + ";");
/* Source line 566 */                 }
/* Source line 567 */             }
/* Source line 568 */         } // end iteration over supported return types
/* Source line 569 */             if (data.isArrayReturnTypeSupported()) {
/* Source line 570 */             println("case " + ARRAY_TYPE + ": { /* ARRAY */");
/* Source line 571 */             println("short elementType = in.readShort();");
/* Source line 572 */             println("length = in.readInt();");
/* Source line 573 */             println("switch (elementType) {");
/* Source line 574 */             for( Iterator it = readableTypes.iterator(); it.hasNext(); ) {
/* Source line 575 */                 ClassData supportedType = (ClassData)it.next();
/* Source line 576 */                 if (supportedType.isArray()) {
/* Source line 577 */                     ClassData elementType = supportedType.getComponentType();
/* Source line 578 */                     Serializer s = elementType.getSerializer();
/* Source line 579 */                     if( s instanceof ComplexTypeSerializer ) {
/* Source line 580 */                         ((ComplexTypeSerializer)s).setClient( support.isClient());
/* Source line 581 */                     }
/* Source line 582 */                     println("case " + s.getType() + ": {");
/* Source line 583 */                     println("" + elementType.getShortClassName() + "[] data = new " + elementType.getShortClassName() + "[length];");
/* Source line 584 */                     if (elementType.isPrimitive()) {
/* Source line 585 */                         // special optimization for byte[]
/* Source line 586 */                         if (elementType.equalsClass(Byte.TYPE)) {
/* Source line 587 */                             println("in.readFully(data);");
/* Source line 588 */                         } else {
/* Source line 589 */                             println("for (int i = 0; i < length; i++) {");
/* Source line 590 */                             println("" + s.read("in", false, "data[i]") + ";");
/* Source line 591 */                             println("}");
/* Source line 592 */                         }
/* Source line 593 */                     } else { // object array
/* Source line 594 */                         println("for (int i = 0; i < length; i++) {");
/* Source line 595 */                         println("data[i] = (" + elementType.getShortClassName() + ") readObject(in);");
/* Source line 596 */                         println("}");
/* Source line 597 */                     } // end is element primitive
/* Source line 598 */                         println("return data;");
/* Source line 599 */                     println("}");
/* Source line 600 */                 }
/* Source line 601 */             }
/* Source line 602 */             println("}");
/* Source line 603 */             println("}");
/* Source line 604 */         } // end is array return type supported
/* Source line 605 */             println("case -1: /* NULL */");
/* Source line 606 */         println("return null;");
/* Source line 607 */         println("}");
/* Source line 608 */         println("throw new IllegalArgumentException(\"Unsupported return type (\" + type + \")\");");
/* Source line 609 */         println("}");
/* Source line 610 */         println("}");
    }

}
