package com.sun.kvem.javon.template;

import java.io.IOException;
import com.sun.kvem.javon.template.Template;
import com.sun.kvem.javon.template.TemplateData;
import com.sun.kvem.javon.model.JavonMapping;
import com.sun.kvem.javon.model.*;
import com.sun.kvem.javon.model.classdata.*;
import java.util.*;

public class Servlet extends Template {

    protected Class getTemplateOutputClass() {
        return com.sun.kvem.javon.model.JavonOutput.class;
    }

    protected com.sun.kvem.javon.model.JavonOutput getOutput() {
        return (com.sun.kvem.javon.model.JavonOutput) getOutputImpl();
    }

    public void runImpl(TemplateData __template_data)
        throws Exception {

    final com.sun.kvem.javon.model.JavonMapping data = (com.sun.kvem.javon.model.JavonMapping) __template_data;
/* Source line 4 */         
/* Source line 5 */         final String VERSION_STRING = (String) data.get("VERSION");
/* Source line 6 */         ProtocolSupport support = new ProtocolSupport(data, this, false);
/* Source line 7 */         setOut(support.getServerPath(data.getServerClassName()));
/* Source line 8 */         getOutput().setServlet(true);
/* Source line 9 */         getOutput().addCreatedFile( support.getServerPath(data.getServerClassName()));
/* Source line 10 */         println("" + support.serverPackageLine() + "");
/* Source line 11 */         println("import " + support.serverSupportPackage() + ".EndToEndGateways;");
/* Source line 12 */         println("import " + support.serverSupportPackage() + ".InvocationAbstraction;");
/* Source line 13 */         println("import " + support.serverSupportPackage() + ".Utility;");
/* Source line 14 */         println("import javax.servlet.http.*;");
/* Source line 15 */         println("import javax.servlet.*;");
/* Source line 16 */         println("import java.io.*;");
/* Source line 17 */         println("import java.util.HashMap;");
/* Source line 18 */         println("import java.util.Map;");
/* Source line 19 */         println("");
/* Source line 20 */         println("/**");
/* Source line 21 */         println("* An automatically-generated servlet gateway. This servlet provides");
/* Source line 22 */         println("* J2ME access to the following server-side methods and classes:");
/* Source line 23 */         println("*");
/* Source line 24 */         println("* <ul>");
/* Source line 25 */         MethodData[] methods = data.getMethods();
/* Source line 26 */         for (int i = 0; i < methods.length; i++) {
/* Source line 27 */             println("*  <li> " + methods[i].getClassData().getClassName() + "." + methods[i].getName() + "");
/* Source line 28 */         }
/* Source line 29 */         println("* </ul>");
/* Source line 30 */         println("*/");
/* Source line 31 */         println("public class " + data.getServerClassName() + " extends HttpServlet {");
/* Source line 32 */         println("");
/* Source line 33 */         println("/**");
/* Source line 34 */         println("* Tracing flag");
/* Source line 35 */         println("*/");
/* Source line 36 */         println("private static int traceOutput = " + data.getServerTraceLevel() + ";");
/* Source line 37 */         println("");
/* Source line 38 */         println("/**");
/* Source line 39 */         println("*  This constant indicates the command code for an invocation in the standard");
/* Source line 40 */         println("*  protocol.");
/* Source line 41 */         println("*/");
/* Source line 42 */         println("private final static short INVOCATION_CODE = 1;");
/* Source line 43 */         println("");
/* Source line 44 */         println("/**");
/* Source line 45 */         println("*  This member indicates a successful result");
/* Source line 46 */         println("*/");
/* Source line 47 */         println("private final static short RESULT_SUCCESSFUL = 1;");
/* Source line 48 */         println("");
/* Source line 49 */         println("/**");
/* Source line 50 */         println("*  This member indicates a server side exception");
/* Source line 51 */         println("*/");
/* Source line 52 */         println("private final static short RESULT_EXCEPTION = 2;");
/* Source line 53 */         println("");
/* Source line 54 */         println("/**");
/* Source line 55 */         println("* The version string for the protocol. This must match the client's");
/* Source line 56 */         println("* version");
/* Source line 57 */         println("*/");
/* Source line 58 */         println("private final static String PROTOCOL_VERSION = \"" + VERSION_STRING + "\";");
/* Source line 59 */         println("");
/* Source line 60 */         println("private boolean traceProtocol = true;");
/* Source line 61 */         println("");
/* Source line 62 */         println("/**");
/* Source line 63 */         println("*  This member contains the method abstractions that can be invoked by the");
/* Source line 64 */         println("*  servlet.");
/* Source line 65 */         println("*/");
/* Source line 66 */         println("private final static InvocationAbstraction[] METHODS = new InvocationAbstraction[] {");
/* Source line 67 */         println("// the naming convention for method delegates is the method name followed");
/* Source line 68 */         println("// by the word Gateway");
/* Source line 69 */         ArrayList methodList = new ArrayList();
/* Source line 70 */         Object EMPTY_VALUE = "";
/* Source line 71 */         for (int i = 0; i < methods.length; i++) {
/* Source line 72 */             int id = methods[i].getRequestID();
/* Source line 73 */             while (methodList.size() <= id) {
/* Source line 74 */                 methodList.add(EMPTY_VALUE);
/* Source line 75 */             }
/* Source line 76 */             methodList.set(id, methods[i]);
/* Source line 77 */         } // end iterating over methods[]
/* Source line 78 */             
/* Source line 79 */             // populate METHODS array
/* Source line 80 */             for (Iterator i = methodList.iterator(); i.hasNext();) {
/* Source line 81 */                 Object next = i.next();
/* Source line 82 */                 if (next == EMPTY_VALUE) {
/* Source line 83 */                     println("null,");
/* Source line 84 */                 } else {
/* Source line 85 */                     MethodData method = (MethodData) next;
/* Source line 86 */                     println("new EndToEndGateways." + method.getImplementingClassName() + "(),");
/* Source line 87 */                 }
/* Source line 88 */             } // finish populating METHODS array
/* Source line 89 */                 println("};");
/* Source line 90 */             println("");
/* Source line 91 */             println("/**");
/* Source line 92 */             println("* Called to handle a GET request. Returns a message that the servlet");
/* Source line 93 */             println("* is deployed");
/* Source line 94 */             println("*/");
/* Source line 95 */             println("protected void doGet(HttpServletRequest req, HttpServletResponse resp)");
/* Source line 96 */             println("throws ServletException, IOException {");
/* Source line 97 */             println("resp.setContentType(\"text/html; charset=iso-8859-1\");");
/* Source line 98 */             println("String title = \"" + data.getServerClassName() + " servlet status\";");
/* Source line 99 */             println("String message = \"" + data.getServerClassName() + " servlet active\";");
/* Source line 100 */             println("OutputStream os = resp.getOutputStream();");
/* Source line 101 */             println("String response = \"<!DOCTYPE HTML PUBLIC \\\"-//W3C//DTD HTML 4.01 Transitional//EN\\\"\\n\" +");
/* Source line 102 */             println("\"\\\"http://www.w3.org/TR/REC-html40/loose.dtd\\\">\\n\" +");
/* Source line 103 */             println("\"<html>\\n<head>\\n\" +");
/* Source line 104 */             println("\"<meta http-equiv=\\\"Content-Type\\\" content=\\\"text/html; charset=iso-8859-1\\\">\" +");
/* Source line 105 */             println("\"<title>\" + title + \"</title>\\n\" +");
/* Source line 106 */             println("\"</head>\\n<body>\\n\" +");
/* Source line 107 */             println("\"<center><h1>\" + message + \"</h1></center>\\n\" +");
/* Source line 108 */             println("\"</body>\\n</html>\\n\";");
/* Source line 109 */             println("os.write(response.getBytes(\"ISO-8859-1\"));");
/* Source line 110 */             println("os.close();");
/* Source line 111 */             println("}");
/* Source line 112 */             println("");
/* Source line 113 */             println("/**");
/* Source line 114 */             println("*  Called by the server (via the service method) to allow a servlet to handle");
/* Source line 115 */             println("*  a POST request. This method dispatches the calls to the underlying class.");
/* Source line 116 */             println("*");
/* Source line 117 */             println("*@param  req                   an HttpServletRequest object that contains the");
/* Source line 118 */             println("*      request the client has made of the servlet");
/* Source line 119 */             println("*@param  resp                  an HttpServletResponse object that contains the");
/* Source line 120 */             println("*      response the servlet sends to the client");
/* Source line 121 */             println("*@exception  ServletException  - if the request for the POST could not be");
/* Source line 122 */             println("*      handled");
/* Source line 123 */             println("*@exception  IOException       Description of Exception");
/* Source line 124 */             println("*/");
/* Source line 125 */             println("protected void doPost( HttpServletRequest req, HttpServletResponse resp )");
/* Source line 126 */             println("throws ServletException, IOException {");
/* Source line 127 */             println("resp.setContentType(\"application/octet-stream\");");
/* Source line 128 */             println("ByteArrayOutputStream baos = new ByteArrayOutputStream();");
/* Source line 129 */             println("DataOutputStream outputStream = new DataOutputStream(baos);");
/* Source line 130 */             println("DataOutput out = getDataOutput(outputStream);");
/* Source line 131 */             println("try {");
/* Source line 132 */             println("short resultCode = RESULT_SUCCESSFUL;");
/* Source line 133 */             println("DataInputStream in = new DataInputStream(req.getInputStream());");
/* Source line 134 */             println("");
/* Source line 135 */             println("HttpSession session = req.getSession(true);");
/* Source line 136 */             println("");
/* Source line 137 */             println("String versionString = req.getHeader(\"version\");");
/* Source line 138 */             println("if (versionString != null) {");
/* Source line 139 */             println("if (!versionString.equals(PROTOCOL_VERSION)) {");
/* Source line 140 */             println("throw new IOException(\"Incompatible protocol version: \"");
/* Source line 141 */             println("+ \"Client's version '\" + versionString + \"' \"");
/* Source line 142 */             println("+ \"does not match server's version '\"");
/* Source line 143 */             println("+ PROTOCOL_VERSION + \"'\");");
/* Source line 144 */             println("}");
/* Source line 145 */             println("if (traceProtocol) {");
/* Source line 146 */             println("System.out.println(\"Protocol versions match: \" + PROTOCOL_VERSION);");
/* Source line 147 */             println("}");
/* Source line 148 */             println("}");
/* Source line 149 */             println("");
/* Source line 150 */             println("short commandCode = in.readShort();");
/* Source line 151 */             println("");
/* Source line 152 */             println("if ( commandCode == INVOCATION_CODE ) {");
/* Source line 153 */             println("// read the number of invocations that are grouped within this call");
/* Source line 154 */             println("short groupCount = in.readShort();");
/* Source line 155 */             println("Object[] returnValues = new Object[groupCount];");
/* Source line 156 */             println("for ( short iter = 0; iter < groupCount; iter++ ) {");
/* Source line 157 */             println("int requestID = in.readInt();");
/* Source line 158 */             println("if (traceProtocol) {");
/* Source line 159 */             println("System.out.println(\"Calling method \" + requestID");
/* Source line 160 */             println("+ \" on server (\"");
/* Source line 161 */             println("+ METHODS[requestID].getClass().getName()");
/* Source line 162 */             println("+ \")\");");
/* Source line 163 */             println("}");
/* Source line 164 */             println("returnValues[iter] = invokeMethod(session, requestID, in);");
/* Source line 165 */             println("}");
/* Source line 166 */             println("out.writeShort(resultCode);");
/* Source line 167 */             println("Utility.writeResults(out, returnValues);");
/* Source line 168 */             println("}");
/* Source line 169 */             println("");
/* Source line 170 */             println("in.close();");
/* Source line 171 */             println("} catch ( Exception err ) {");
/* Source line 172 */             println("if (outputStream == null) {");
/* Source line 173 */             println("outputStream = new DataOutputStream(resp.getOutputStream());");
/* Source line 174 */             println("out = getDataOutput(outputStream);");
/* Source line 175 */             println("}");
/* Source line 176 */             println("");
/* Source line 177 */             println("out.writeShort(RESULT_EXCEPTION);");
/* Source line 178 */             println("err.printStackTrace();");
/* Source line 179 */             println("String errMessage = err.getMessage();");
/* Source line 180 */             println("if (errMessage == null) {");
/* Source line 181 */             println("errMessage = \"\";");
/* Source line 182 */             println("}");
/* Source line 183 */             println("if (err instanceof IOException) {");
/* Source line 184 */             println("Utility.writeObject(out, err.getMessage());");
/* Source line 185 */             println("} else {");
/* Source line 186 */             println("if (errMessage.length() > 0) {");
/* Source line 187 */             println("errMessage = \": \" + errMessage;");
/* Source line 188 */             println("}");
/* Source line 189 */             println("Utility.writeObject(out, err.getClass().getName() + err.getMessage());");
/* Source line 190 */             println("}");
/* Source line 191 */             println("}");
/* Source line 192 */             println("outputStream.close();");
/* Source line 193 */             println("byte[] outputData = baos.toByteArray();");
/* Source line 194 */             println("resp.setContentLength(outputData.length);");
/* Source line 195 */             println("OutputStream httpOutputStream = resp.getOutputStream();");
/* Source line 196 */             println("try {");
/* Source line 197 */             println("httpOutputStream.write(outputData);");
/* Source line 198 */             println("} finally {");
/* Source line 199 */             println("httpOutputStream.close();");
/* Source line 200 */             println("}");
/* Source line 201 */             println("}");
/* Source line 202 */             println("");
/* Source line 203 */             println("protected DataOutput getDataOutput(DataOutput out) {");
/* Source line 204 */             println("if (traceOutput > 0) {");
/* Source line 205 */             println("return new Utility.CompositeDataOutput(new DataOutput[] {");
/* Source line 206 */             println("new Utility.TracedDataOutput(System.out),");
/* Source line 207 */             println("out");
/* Source line 208 */             println("});");
/* Source line 209 */             println("} else {");
/* Source line 210 */             println("return out;");
/* Source line 211 */             println("}");
/* Source line 212 */             println("}");
/* Source line 213 */             println("");
/* Source line 214 */             println("/**");
/* Source line 215 */             println("*  This method performs the actual invocation of server functionality.");
/* Source line 216 */             println("*");
/* Source line 217 */             println("*@param  session          The http session");
/* Source line 218 */             println("*@param  requestID        The id of a specific method invocation");
/* Source line 219 */             println("*@param  input            The stream from which we should read the parameters");
/* Source line 220 */             println("*      for the methods");
/* Source line 221 */             println("*@return                  Description of the Returned Value");
/* Source line 222 */             println("*@exception  IOException  Thrown when a protocol/response error occurs");
/* Source line 223 */             println("*/");
/* Source line 224 */             println("private Object invokeMethod(HttpSession session,");
/* Source line 225 */             println("int requestID,");
/* Source line 226 */             println("DataInput input) throws Exception {");
/* Source line 227 */             println("");
/* Source line 228 */             println("return METHODS[requestID].invoke(session, input);");
/* Source line 229 */             println("}");
/* Source line 230 */             println("}");
    }

}
