package com.sun.kvem.javon.template;

import java.io.IOException;
import com.sun.kvem.javon.template.Template;
import com.sun.kvem.javon.template.TemplateData;
import com.sun.kvem.javon.model.JavonMapping;
import com.sun.kvem.javon.model.*;
import com.sun.kvem.javon.model.protocol.binary.ComplexTypeSerializer;
import com.sun.kvem.javon.model.classdata.*;
import com.sun.kvem.javon.model.protocol.Serializer;
import java.util.*;
import java.io.File;

public class Structures extends Template {

    protected Class getTemplateOutputClass() {
        return com.sun.kvem.javon.model.JavonOutput.class;
    }

    protected com.sun.kvem.javon.model.JavonOutput getOutput() {
        return (com.sun.kvem.javon.model.JavonOutput) getOutputImpl();
    }

    public void runImpl(TemplateData __template_data)
        throws Exception {

    final com.sun.kvem.javon.model.JavonMapping data = (com.sun.kvem.javon.model.JavonMapping) __template_data;
/* Source line 7 */         
/* Source line 8 */         ProtocolSupport support = new ProtocolSupport(data, this, true);
/* Source line 9 */         String outputDir = data.getClientOutputDirectory();
/* Source line 10 */         ClassData[] types = data.getSupportedTypes();
/* Source line 11 */         for( int i = 0; i < types.length; i++ ) {
/* Source line 12 */             Serializer serializer = types[i].getSerializer();
/* Source line 13 */             if(!( serializer instanceof ComplexTypeSerializer )) continue;
/* Source line 14 */             ClassData beanType = types[i];
/* Source line 15 */             
/* Source line 16 */             String fileName = data.getClientRootDirectory() + File.separator + beanType.getClassName().replace( '.', File.separatorChar ) + ".java";
/* Source line 17 */             setOut( fileName );
/* Source line 18 */             getOutput().addCreatedFile( fileName );
/* Source line 19 */             if( !beanType.getPackageName().equals( "" )) {
/* Source line 20 */                 println("package " + beanType.getPackageName() + ";");
/* Source line 21 */                 println("");
/* Source line 22 */             }
/* Source line 23 */             FieldData[] fields = beanType.getFields();
/* Source line 24 */             boolean vector = false, hashtable = false, date = false;
/* Source line 25 */             for( int j = 0; j < fields.length; j++ ) {
/* Source line 26 */                 if( fields[j].isInherited()) continue;
/* Source line 27 */                 String className = fields[j].getType().getClassName();
/* Source line 28 */                 if( "java.util.Vector".equals( className )) {
/* Source line 29 */                     vector = true;
/* Source line 30 */                 } else if( "java.util.Hashtable".equals( className )) {
/* Source line 31 */                     hashtable = true;
/* Source line 32 */                 } else if( "java.util.Date".equals( className )) {
/* Source line 33 */                     date = true;
/* Source line 34 */                 }
/* Source line 35 */             }
/* Source line 36 */             if( vector ) {
/* Source line 37 */                 println("import java.util.Vector;");
/* Source line 38 */             }
/* Source line 39 */             if( hashtable ) {
/* Source line 40 */                 println("import java.util.Hashtable;");
/* Source line 41 */             }
/* Source line 42 */             if( date ) {
/* Source line 43 */                 println("import java.util.Date;");
/* Source line 44 */             }
/* Source line 45 */             println("");
/* Source line 46 */             if( "java.lang.Object".equals( beanType.getSuperClassName())) {
/* Source line 47 */                 println("public class " + beanType.getLeafClassName() + " {");
/* Source line 48 */             } else {
/* Source line 49 */                 println("public class " + beanType.getLeafClassName() + " extends " + beanType.getSuperClassName() + " {");
/* Source line 50 */             }
/* Source line 51 */             println("");
/* Source line 52 */             for( int j = 0; j < fields.length; j++ ) {
/* Source line 53 */                 if( fields[j].isInherited()) continue;
/* Source line 54 */                 String fieldTypeName = fields[j].getType().getClassName();
/* Source line 55 */                 if( fieldTypeName.startsWith( "java.lang" )) {
/* Source line 56 */                     fieldTypeName = fieldTypeName.substring( "java.lang.".length());
/* Source line 57 */                 }
/* Source line 58 */                 println("public " + fieldTypeName + " " + fields[j].getName() + ";");
/* Source line 59 */             }
/* Source line 60 */             println("");
/* Source line 61 */             println("}");
/* Source line 62 */             
/* Source line 63 */         }
    }

}
