package com.sun.kvem.javon.template;

import java.io.IOException;
import com.sun.kvem.javon.template.Template;
import com.sun.kvem.javon.template.TemplateData;
import com.sun.kvem.javon.model.JavonMapping;
import java.io.File;
import com.sun.kvem.javon.model.*;
import com.sun.kvem.javon.model.classdata.ClassData;
import com.sun.kvem.javon.model.protocol.Serializer;
import com.sun.kvem.javon.model.protocol.binary.ComplexTypeSerializer;
import com.sun.kvem.javon.model.protocol.binary.PrimitiveTypeSerializer;
import java.util.*;

public class Utility extends Template {

    protected Class getTemplateOutputClass() {
        return com.sun.kvem.javon.model.JavonOutput.class;
    }

    protected com.sun.kvem.javon.model.JavonOutput getOutput() {
        return (com.sun.kvem.javon.model.JavonOutput) getOutputImpl();
    }

    public void runImpl(TemplateData __template_data)
        throws Exception {

    final com.sun.kvem.javon.model.JavonMapping data = (com.sun.kvem.javon.model.JavonMapping) __template_data;
/* Source line 8 */         ProtocolSupport support = new ProtocolSupport(data, this, false);
/* Source line 9 */         setOut(support.getServletSupportPath("Utility"));
/* Source line 10 */         getOutput().addCreatedFile( support.getServletSupportPath("Utility"));
/* Source line 11 */         println("");
/* Source line 12 */         println("package " + support.serverSupportPackage() + ";");
/* Source line 13 */         println("");
/* Source line 14 */         println("import java.io.*;");
/* Source line 15 */         println("import java.lang.reflect.*;");
/* Source line 16 */         println("");
/* Source line 17 */         println("/**");
/* Source line 18 */         println("*  This class is used as an external protocol utility. It is so we don't");
/* Source line 19 */         println("*  generate as much code.");
/* Source line 20 */         println("*/");
/* Source line 21 */         println("");
/* Source line 22 */         println("public class Utility {");
/* Source line 23 */         println("");
/* Source line 24 */         ClassData[] supportedParamTypes = data.getParameterTypes();
/* Source line 25 */         ClassData[] supportedReturnTypes = data.getReturnTypes();
/* Source line 26 */         Set allTypes = new HashSet();
/* Source line 27 */         allTypes.addAll(Arrays.asList(supportedParamTypes));
/* Source line 28 */         allTypes.addAll(Arrays.asList(supportedReturnTypes));
/* Source line 29 */         Set includedTypes = new HashSet();
/* Source line 30 */         boolean arrayTypeSupported = false;
/* Source line 31 */         for (Iterator i = allTypes.iterator(); i.hasNext(); ) {
/* Source line 32 */             ClassData type = (ClassData)i.next();
/* Source line 33 */             if (type.isArray()) {
/* Source line 34 */                 arrayTypeSupported = true;
/* Source line 35 */                 while (type.isArray()) {
/* Source line 36 */                     type = type.getComponentType();
/* Source line 37 */                 }
/* Source line 38 */             }
/* Source line 39 */             if (!includedTypes.contains(type)) {
/* Source line 40 */                 int typeIndex = data.getValueForType(type);
/* Source line 41 */                 Serializer s = type.getSerializer();
/* Source line 42 */                 if( s instanceof PrimitiveTypeSerializer && !type.isPrimitive()) {
/* Source line 43 */                     continue;
/* Source line 44 */                 }
/* Source line 45 */                 // reset the type strings to be only the constant
/* Source line 46 */                 s.setType(null);
/* Source line 47 */                 println("private final static short " + s.getTypeConstant() + " = " + typeIndex + ";");
/* Source line 48 */                 includedTypes.add(type);
/* Source line 49 */             }
/* Source line 50 */         } // end iteration over allTypes
/* Source line 51 */             println("");
/* Source line 52 */         println("/** Type value for arrays. */");
/* Source line 53 */         println("private final static short ARRAY_TYPE = -2;");
/* Source line 54 */         println("");
/* Source line 55 */         println("/** Marker for null. Null is a type and a value together. */");
/* Source line 56 */         println("private final static short NULL_TYPE = -1;");
/* Source line 57 */         println("");
/* Source line 58 */         println("/** Marker for void return types. */");
/* Source line 59 */         println("public final static Object VOID_VALUE = new Object();");
/* Source line 60 */         println("");
/* Source line 61 */         println("/** Compute the type value for a given class");
/* Source line 62 */         println("* @param clazz An object to be send to the client");
/* Source line 63 */         println("* @return a type value to identify the object");
/* Source line 64 */         println("*/");
/* Source line 65 */         println("private static short getType(Class clazz) {");
/* Source line 66 */         println("String className = clazz.getName();");
/* Source line 67 */         Set baseReturnTypes = new HashSet();
/* Source line 68 */         for (int i = 0; i < supportedReturnTypes.length; i++) {
/* Source line 69 */             ClassData type = supportedReturnTypes[i];
/* Source line 70 */             while (type.isArray()) {
/* Source line 71 */                 type = type.getComponentType();
/* Source line 72 */             }
/* Source line 73 */             baseReturnTypes.add(type);
/* Source line 74 */         }
/* Source line 75 */         for (Iterator i = baseReturnTypes.iterator(); i.hasNext(); ) {
/* Source line 76 */             ClassData type = (ClassData) i.next();
/* Source line 77 */             Serializer s = type.getSerializer();
/* Source line 78 */             println("if (className.equals(\"" + type.getClassName() + "\")) {");
/* Source line 79 */             println("return " + s.getTypeConstant() + ";");
/* Source line 80 */             println("}");
/* Source line 81 */         }
/* Source line 82 */         if (data.isArrayReturnTypeSupported()) {
/* Source line 83 */             println("if (className.startsWith(\"[\")) {");
/* Source line 84 */             println("return ARRAY_TYPE;");
/* Source line 85 */             println("}");
/* Source line 86 */         } // end is array return type supported
/* Source line 87 */             println("");
/* Source line 88 */         println("throw new IllegalArgumentException(\"Unsupported type (\" + className + \")\");");
/* Source line 89 */         println("}");
/* Source line 90 */         println("");
/* Source line 91 */         if (data.isArrayParameterSupported()) {
/* Source line 92 */             println("/**");
/* Source line 93 */             println("* Reads an array from the given data source and returns it.");
/* Source line 94 */             println("*");
/* Source line 95 */             println("*@param  source           The source from which the data is extracted.");
/* Source line 96 */             println("*@return                  The array from the data source");
/* Source line 97 */             println("*@exception  IOException  If an error occured while reading the data.");
/* Source line 98 */             println("*/");
/* Source line 99 */             println("public static Object readArray(DataInput in) throws IOException {");
/* Source line 100 */             println("short type = in.readShort();");
/* Source line 101 */             println("int length = in.readInt();");
/* Source line 102 */             println("if (length == -1) {");
/* Source line 103 */             println("return null;");
/* Source line 104 */             println("} else {");
/* Source line 105 */             println("switch (type) {");
/* Source line 106 */             for (int i = 0; i < supportedParamTypes.length; i++) {
/* Source line 107 */                 ClassData type = supportedParamTypes[i];
/* Source line 108 */                 if (type.isArray()) {
/* Source line 109 */                     while (type.isArray()) {
/* Source line 110 */                         type = type.getComponentType();
/* Source line 111 */                     }
/* Source line 112 */                     Serializer s = type.getSerializer();
/* Source line 113 */                     println("case " + s.getTypeConstant() + ": {");
/* Source line 114 */                     println("" + type.getShortClassName() + "[] data = new " + type.getShortClassName() + "[length];");
/* Source line 115 */                     if (type.isPrimitive()) {
/* Source line 116 */                         // special optimization for byte[]
/* Source line 117 */                         if (type.equalsClass(Byte.TYPE)) {
/* Source line 118 */                             println("in.readFully(data);");
/* Source line 119 */                         } else {
/* Source line 120 */                             println("for (int i = 0; i < length; i++) {");
/* Source line 121 */                             println("" + s.read("in", false, "data[i]") + ";");
/* Source line 122 */                             println("}");
/* Source line 123 */                         }
/* Source line 124 */                     } else {
/* Source line 125 */                         println("for (int i = 0; i < length; i++) {");
/* Source line 126 */                         println("data[i] = (" + type.getShortClassName() + ") readObject(in);");
/* Source line 127 */                         println("}");
/* Source line 128 */                     }
/* Source line 129 */                     println("return data;");
/* Source line 130 */                     println("}");
/* Source line 131 */                 }
/* Source line 132 */             }
/* Source line 133 */             println("default: {");
/* Source line 134 */             println("throw new IllegalArgumentException(\"Unsupported return type (\" + type + \")\");");
/* Source line 135 */             println("}");
/* Source line 136 */             println("}");
/* Source line 137 */             println("}");
/* Source line 138 */             println("}");
/* Source line 139 */         } // isArrayParameterSupported()
/* Source line 140 */             println("");
/* Source line 141 */         println("/**");
/* Source line 142 */         println("*  Sends return values to the client output stream.");
/* Source line 143 */         println("*");
/* Source line 144 */         println("*@param  output           The output stream into which all the data should be");
/* Source line 145 */         println("*      written");
/* Source line 146 */         println("*@param  returnValues     The values which we should write into the stream");
/* Source line 147 */         println("*@exception  IOException  If an error occured while writing the results");
/* Source line 148 */         println("*/");
/* Source line 149 */         println("public static void writeResults( DataOutput output, Object[] returnValues) throws IOException {");
/* Source line 150 */         println("for ( int i = 0; i < returnValues.length; i++ ) {");
/* Source line 151 */         println("writeObject(output, returnValues[i]);");
/* Source line 152 */         println("}");
/* Source line 153 */         println("}");
/* Source line 154 */         println("");
/* Source line 155 */         println("public static void writeObject(DataOutput output, Object o) throws IOException {");
/* Source line 156 */         println("if (o == null) { // return null");
/* Source line 157 */         println("output.writeShort(NULL_TYPE);");
/* Source line 158 */         if (data.isReturnTypeSupported(Void.TYPE)) {
/* Source line 159 */             println("} else if (o == VOID_VALUE) { // return void");
/* Source line 160 */             println("output.writeShort(VOID_TYPE);");
/* Source line 161 */         } // end is void return type supported
/* Source line 162 */             Set writableTypes = new HashSet();
/* Source line 163 */         for( int i = 0; i < supportedReturnTypes.length; i++ ) {
/* Source line 164 */             ClassData type = supportedReturnTypes[i];
/* Source line 165 */             if( !type.isPrimitive() && type.getSerializer() instanceof PrimitiveTypeSerializer ) {
/* Source line 166 */                 continue;
/* Source line 167 */             }
/* Source line 168 */             writableTypes.add( type );
/* Source line 169 */         }
/* Source line 170 */         if (data.isArrayReturnTypeSupported()) {
/* Source line 171 */             println("} else if (o.getClass().isArray()) {");
/* Source line 172 */             println("output.writeShort(ARRAY_TYPE);");
/* Source line 173 */             println("short elementType = getType(o.getClass().getComponentType());");
/* Source line 174 */             println("output.writeShort(elementType);");
/* Source line 175 */             println("switch (elementType) {");
/* Source line 176 */             for( Iterator it = writableTypes.iterator(); it.hasNext(); ) {
/* Source line 177 */                 ClassData type = (ClassData)it.next();
/* Source line 178 */                 if (type.isArray()) {
/* Source line 179 */                     type = type.getComponentType();
/* Source line 180 */                     if (type.isPrimitive()) {
/* Source line 181 */                         Serializer s = type.getSerializer();
/* Source line 182 */                         if( s instanceof ComplexTypeSerializer ) {
/* Source line 183 */                             ((ComplexTypeSerializer)s).setClient( false );
/* Source line 184 */                         }
/* Source line 185 */                         println("case " + s.getTypeConstant() + ": {");
/* Source line 186 */                         println("" + type.getShortClassName() + "[] array = (" + type.getShortClassName() + "[]) o;");
/* Source line 187 */                         println("output.writeInt(array.length);");
/* Source line 188 */                         println("for (int i = 0; i < array.length; i++) {");
/* Source line 189 */                         println("" + s.writeObject("output", "array[i]") + "");
/* Source line 190 */                         println("}");
/* Source line 191 */                         println("break;");
/* Source line 192 */                         println("}");
/* Source line 193 */                     }
/* Source line 194 */                 }
/* Source line 195 */             }
/* Source line 196 */             println("default: {");
/* Source line 197 */             println("int length = Array.getLength(o);");
/* Source line 198 */             println("output.writeInt(length);");
/* Source line 199 */             println("for (int i = 0; i < length; i++) {");
/* Source line 200 */             println("writeObject(output, Array.get(o, i));");
/* Source line 201 */             println("}");
/* Source line 202 */             println("}");
/* Source line 203 */             println("");
/* Source line 204 */             println("}");
/* Source line 205 */         } // end isArrayReturnTypeSupported
/* Source line 206 */             for( Iterator it = writableTypes.iterator(); it.hasNext(); ) {
/* Source line 207 */                 ClassData type = (ClassData)it.next();
/* Source line 208 */                 if (type.isArray()) {
/* Source line 209 */                     continue;
/* Source line 210 */                 }
/* Source line 211 */                 String typeName;
/* Source line 212 */                 if (type.isPrimitive()) {
/* Source line 213 */                     typeName = type.getWrapperType().getShortClassName();
/* Source line 214 */                 } else {
/* Source line 215 */                     typeName = type.getShortClassName();
/* Source line 216 */                 }
/* Source line 217 */                 Serializer s = type.getSerializer();
/* Source line 218 */                 if( s instanceof ComplexTypeSerializer ) {
/* Source line 219 */                     ((ComplexTypeSerializer)s).setClient( false );
/* Source line 220 */                 }
/* Source line 221 */                 println("} else if (o instanceof " + typeName + ") {");
/* Source line 222 */                 println("" + s.writeType("output") + "");
/* Source line 223 */                 println("" + s.writeObject("output", support.castFromReference("o", type)) + "");
/* Source line 224 */             }
/* Source line 225 */             println("}");
/* Source line 226 */             println("}");
/* Source line 227 */             println("");
/* Source line 228 */             println("static Object toObject(byte b) {");
/* Source line 229 */             println("return new Byte(b);");
/* Source line 230 */             println("}");
/* Source line 231 */             println("");
/* Source line 232 */             println("static Object toObject(short s) {");
/* Source line 233 */             println("return new Short(s);");
/* Source line 234 */             println("}");
/* Source line 235 */             println("");
/* Source line 236 */             println("static Object toObject(char c) {");
/* Source line 237 */             println("return new Character(c);");
/* Source line 238 */             println("}");
/* Source line 239 */             println("");
/* Source line 240 */             println("static Object toObject(int i) {");
/* Source line 241 */             println("return new Integer(i);");
/* Source line 242 */             println("}");
/* Source line 243 */             println("");
/* Source line 244 */             println("static Object toObject(long l) {");
/* Source line 245 */             println("return new Long(l);");
/* Source line 246 */             println("}");
/* Source line 247 */             println("");
/* Source line 248 */             println("static Object toObject(float f) {");
/* Source line 249 */             println("return new Float(f);");
/* Source line 250 */             println("}");
/* Source line 251 */             println("");
/* Source line 252 */             println("static Object toObject(double d) {");
/* Source line 253 */             println("return new Double(d);");
/* Source line 254 */             println("}");
/* Source line 255 */             println("");
/* Source line 256 */             println("static Object toObject(boolean b) {");
/* Source line 257 */             println("return new Boolean(b);");
/* Source line 258 */             println("}");
/* Source line 259 */             println("");
/* Source line 260 */             println("static Object toObject(Object o) {");
/* Source line 261 */             println("return o;");
/* Source line 262 */             println("}");
/* Source line 263 */             println("");
/* Source line 264 */             println("protected static Object readObject(DataInput in) throws IOException {");
/* Source line 265 */             println("short type = in.readShort();");
/* Source line 266 */             println("short length;");
/* Source line 267 */             println("switch (type) {");
/* Source line 268 */             //     for (int i = 0; i < supportedReturnTypes.length; i++) {
/* Source line 269 */             //       ClassData type = supportedReturnTypes[i];
/* Source line 270 */             Set readableTypes = new HashSet();
/* Source line 271 */             for( int i = 0; i < supportedParamTypes.length; i++ ) {
/* Source line 272 */                 ClassData type = supportedParamTypes[i];
/* Source line 273 */                 if( !type.isPrimitive() && type.getSerializer() instanceof PrimitiveTypeSerializer ) {
/* Source line 274 */                     continue;
/* Source line 275 */                 }
/* Source line 276 */                 readableTypes.add( type );
/* Source line 277 */             }
/* Source line 278 */             for( Iterator it = readableTypes.iterator(); it.hasNext(); ) {
/* Source line 279 */                 ClassData type = (ClassData)it.next();
/* Source line 280 */                 String typeName;
/* Source line 281 */                 if (type.isPrimitive()) {
/* Source line 282 */                     typeName = type.getWrapperType().getShortClassName();
/* Source line 283 */                 } else {
/* Source line 284 */                     typeName = type.getShortClassName();
/* Source line 285 */                 }
/* Source line 286 */                 if (!type.isArray()) {
/* Source line 287 */                     Serializer s = type.getSerializer();
/* Source line 288 */                     if( s instanceof ComplexTypeSerializer ) {
/* Source line 289 */                         ((ComplexTypeSerializer)s).setClient( false );
/* Source line 290 */                     }
/* Source line 291 */                     if( s instanceof ComplexTypeSerializer || type.isPrimitive()) {
/* Source line 292 */                         println("case " + s.getTypeConstant() + ": /* " + typeName + " */");
/* Source line 293 */                         println("" + s.readAndReturnObject("in") + ";");
/* Source line 294 */                     }
/* Source line 295 */                 }
/* Source line 296 */             }
/* Source line 297 */             if (data.isArrayParameterSupported()) {
/* Source line 298 */                 println("case ARRAY_TYPE:");
/* Source line 299 */                 println("return readArray(in);");
/* Source line 300 */             }
/* Source line 301 */             println("case NULL_TYPE: /* null */");
/* Source line 302 */             println("return null;");
/* Source line 303 */             println("default:");
/* Source line 304 */             println("throw new IllegalArgumentException(");
/* Source line 305 */             println("\"Unsupported return type (\" + type + \")\");");
/* Source line 306 */             println("}");
/* Source line 307 */             println("}");
/* Source line 308 */             println("");
/* Source line 309 */             println("public static class CompositeDataOutput implements DataOutput {");
/* Source line 310 */             println("private DataOutput[] outputs;");
/* Source line 311 */             println("");
/* Source line 312 */             println("public CompositeDataOutput(DataOutput[] outputs) {");
/* Source line 313 */             println("this.outputs = (DataOutput[]) outputs.clone();");
/* Source line 314 */             println("}");
/* Source line 315 */             println("");
/* Source line 316 */             println("public void write(int b) throws IOException {");
/* Source line 317 */             println("this.writeByte(b);");
/* Source line 318 */             println("}");
/* Source line 319 */             println("public void write(byte[] b) throws IOException {");
/* Source line 320 */             println("this.write(b, 0, b.length);");
/* Source line 321 */             println("}");
/* Source line 322 */             println("public void write(byte[] b, int offset, int len) throws IOException {");
/* Source line 323 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 324 */             println("outputs[i].write(b, offset, len);");
/* Source line 325 */             println("}");
/* Source line 326 */             println("}");
/* Source line 327 */             println("public void writeBoolean(boolean b) throws IOException {");
/* Source line 328 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 329 */             println("outputs[i].writeBoolean(b);");
/* Source line 330 */             println("}");
/* Source line 331 */             println("}");
/* Source line 332 */             println("public void writeByte(int b) throws IOException {");
/* Source line 333 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 334 */             println("outputs[i].writeByte(b);");
/* Source line 335 */             println("}");
/* Source line 336 */             println("}");
/* Source line 337 */             println("public void writeBytes(String s) throws IOException {");
/* Source line 338 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 339 */             println("outputs[i].writeBytes(s);");
/* Source line 340 */             println("}");
/* Source line 341 */             println("}");
/* Source line 342 */             println("public void writeChar(int c) throws IOException {");
/* Source line 343 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 344 */             println("outputs[i].writeChar(c);");
/* Source line 345 */             println("}");
/* Source line 346 */             println("}");
/* Source line 347 */             println("public void writeChars(String s) throws IOException {");
/* Source line 348 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 349 */             println("outputs[i].writeChars(s);");
/* Source line 350 */             println("}");
/* Source line 351 */             println("}");
/* Source line 352 */             println("public void writeDouble(double d) throws IOException {");
/* Source line 353 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 354 */             println("outputs[i].writeDouble(d);");
/* Source line 355 */             println("}");
/* Source line 356 */             println("}");
/* Source line 357 */             println("public void writeFloat(float f) throws IOException {");
/* Source line 358 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 359 */             println("outputs[i].writeFloat(f);");
/* Source line 360 */             println("}");
/* Source line 361 */             println("}");
/* Source line 362 */             println("public void writeInt(int value) throws IOException {");
/* Source line 363 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 364 */             println("outputs[i].writeInt(value);");
/* Source line 365 */             println("}");
/* Source line 366 */             println("}");
/* Source line 367 */             println("public void writeLong(long l) throws IOException {");
/* Source line 368 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 369 */             println("outputs[i].writeLong(l);");
/* Source line 370 */             println("}");
/* Source line 371 */             println("}");
/* Source line 372 */             println("public void writeShort(int s) throws IOException {");
/* Source line 373 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 374 */             println("outputs[i].writeShort(s);");
/* Source line 375 */             println("}");
/* Source line 376 */             println("}");
/* Source line 377 */             println("public void writeUTF(String s) throws IOException {");
/* Source line 378 */             println("for (int i = 0; i < outputs.length; i++) {");
/* Source line 379 */             println("outputs[i].writeUTF(s);");
/* Source line 380 */             println("}");
/* Source line 381 */             println("}");
/* Source line 382 */             println("}");
/* Source line 383 */             println("");
/* Source line 384 */             println("public static class TracedDataOutput implements DataOutput {");
/* Source line 385 */             println("private PrintStream log;");
/* Source line 386 */             println("public TracedDataOutput(PrintStream log) {");
/* Source line 387 */             println("this.log = log;");
/* Source line 388 */             println("}");
/* Source line 389 */             println("public void write(int b) throws IOException {");
/* Source line 390 */             println("this.writeByte(b);");
/* Source line 391 */             println("}");
/* Source line 392 */             println("public void write(byte[] b) throws IOException {");
/* Source line 393 */             println("this.write(b, 0, b.length);");
/* Source line 394 */             println("}");
/* Source line 395 */             println("public void write(byte[] b, int offset, int len) throws IOException {");
/* Source line 396 */             println("log.println(\"Writing \" + len + \" bytes\");");
/* Source line 397 */             println("}");
/* Source line 398 */             println("public void writeBoolean(boolean b) throws IOException {");
/* Source line 399 */             println("log.println(\"Writing boolean: \" + b);");
/* Source line 400 */             println("}");
/* Source line 401 */             println("public void writeByte(int b) throws IOException {");
/* Source line 402 */             println("log.println(\"Writing byte: \" + b);");
/* Source line 403 */             println("}");
/* Source line 404 */             println("public void writeBytes(String s) throws IOException {");
/* Source line 405 */             println("log.println(\"Writing bytes: '\" + s + \"'\");");
/* Source line 406 */             println("}");
/* Source line 407 */             println("public void writeChar(int c) throws IOException {");
/* Source line 408 */             println("log.println(\"Writing char: \" + c);");
/* Source line 409 */             println("}");
/* Source line 410 */             println("public void writeChars(String s) throws IOException {");
/* Source line 411 */             println("log.println(\"Writing chars: '\" + s + \"'\");");
/* Source line 412 */             println("}");
/* Source line 413 */             println("public void writeDouble(double d) throws IOException {");
/* Source line 414 */             println("log.println(\"Writing double: \" + d);");
/* Source line 415 */             println("}");
/* Source line 416 */             println("public void writeFloat(float f) throws IOException {");
/* Source line 417 */             println("log.println(\"Writing float: \" + f);");
/* Source line 418 */             println("}");
/* Source line 419 */             println("public void writeInt(int i) throws IOException {");
/* Source line 420 */             println("log.println(\"Writing integer: \" + i);");
/* Source line 421 */             println("}");
/* Source line 422 */             println("public void writeLong(long l) throws IOException {");
/* Source line 423 */             println("log.println(\"Writing long: \" + l);");
/* Source line 424 */             println("}");
/* Source line 425 */             println("public void writeShort(int s) throws IOException {");
/* Source line 426 */             println("log.println(\"Writing short: \" + s);");
/* Source line 427 */             println("}");
/* Source line 428 */             println("public void writeUTF(String s) throws IOException {");
/* Source line 429 */             println("log.println(\"Writing string: '\" + s + \"'\");");
/* Source line 430 */             println("}");
/* Source line 431 */             println("}");
/* Source line 432 */             println("");
/* Source line 433 */             println("}");
    }

}
