/*
 * EnterPasswordTask.java
 *
 * Created on 11. leden 2005, 12:10
 */

package org.netbeans.modules.kjava.j2meproject.ant;

import java.io.File;
import java.util.Map;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import org.netbeans.modules.kjava.j2meproject.ui.security.EnterPasswordPanel;
import org.openide.util.NbBundle;

/**
 *
 * @author Adam Sotona
 */
public class EnterPasswordTask extends Task {

    private static boolean store = true;
    
    /**
     * Holds value of property keyStore.
     */
    private String keyStore;

    /**
     * Holds value of property keyAlias.
     */
    private String keyAlias;

    /**
     * Holds value of property keyFile.
     */
    private String keyFile;

    /**
     * Holds value of property connectionId.
     */
    private String connectionId;

    /**
     * Holds value of property userName.
     */
    private String userName;

    /**
     * Holds value of property userNameProperty.
     */
    private String userNameProperty;

    /**
     * Holds value of property passwordProperty.
     */
    private String passwordProperty;

    /**
     * Holds value of property usePassphrase.
     */
    private boolean usePassphrase = false;
    
    /** Creates a new instance of EnterPasswordTask */
    public EnterPasswordTask() {
    }

    public void execute() throws BuildException {
        if (passwordProperty == null) throw new BuildException(NbBundle.getMessage(EnterPasswordTask.class, "ERR_PasswordPropertyrequired.")); //NOI18N
        boolean a = keyStore != null, b = keyFile != null, c = connectionId != null, d = userNameProperty != null;
        if (a ? b || c : b && c) throw new BuildException(NbBundle.getMessage(EnterPasswordTask.class, "ERR_JustOneOfTheAttributes")); //NOI18N
        if (d && (a || b)) throw new BuildException(NbBundle.getMessage(EnterPasswordTask.class, "ERR_InvalidUsernameUsage")); //NOI18N
        String password = null;
        if (a) {
            if (!new File(keyStore).isFile()) throw new BuildException(NbBundle.getMessage(EnterPasswordTask.class, "ERR_InvalidKeystore")); //NOI18N
            password = keyAlias == null ? EnterPasswordPanel.getKeystorePassword(keyStore) : EnterPasswordPanel.getAliasPassword(keyStore, keyAlias);
        } else if (b) {
            password = EnterPasswordPanel.getKeyfilePassword(keyFile);
        } else if (c) {
            if (d) {
                String[] s  = EnterPasswordPanel.getConnectionUsernameAndPassword(connectionId, userName);
                if (s != null) {
                    getProject().setProperty(userNameProperty, s[0]);
                    password = s[1];
                }
            } else {
                password = EnterPasswordPanel.getConnectionPassword(connectionId, userName);
            }
        } else throw new BuildException(NbBundle.getMessage(EnterPasswordTask.class, "ERR_RequiredAttribute")); //NOI18N
        if (password == null) throw new BuildException(NbBundle.getMessage(EnterPasswordTask.class, "ERR_Cancelled")); //NOI18N
        getProject().setProperty(passwordProperty, password);
    }    

    /**
     * Setter for property keyStore.
     * @param keystore New value of property keyStore.
     */
    public void setKeyStore(String keyStore) {
        this.keyStore = keyStore;
    }

    /**
     * Setter for property keyAlias.
     * @param keyAlias New value of property keyAlias.
     */
    public void setKeyAlias(String keyAlias) {
        this.keyAlias = keyAlias;
    }

    /**
     * Setter for property keyFile.
     * @param keyFile New value of property keyFile.
     */
    public void setKeyFile(String keyFile) {
        this.keyFile = keyFile;
    }

    /**
     * Setter for property connectionId.
     * @param connectionId New value of property connectionId.
     */
    public void setConnectionId(String connectionId) {
        this.connectionId = connectionId;
    }

    /**
     * Setter for property userName.
     * @param userName New value of property userName.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }

    /**
     * Setter for property userNameProperty.
     * @param userNameProperty New value of property userNameProperty.
     */
    public void setUserNameProperty(String userNameProperty) {
        this.userNameProperty = userNameProperty;
    }

    /**
     * Setter for property passwordProperty.
     * @param passwordProperty New value of property passwordProperty.
     */
    public void setPasswordProperty(String passwordProperty) {
        this.passwordProperty = passwordProperty;
    }

    /**
     * Setter for property usePassphrase.
     * @param usePassphrase New value of property usePassphrase.
     */
    public void setUsePassphrase(boolean usePassphrase) {
        this.usePassphrase = usePassphrase;
    }
}
